/*
 *       OMEGA SECURITY SERVICES
 *        (C) 2008 Omega Team
 *
 * Contact us at bugs@taazoo.net
 *
 * For COPYING instructions please read
 * the LICENSE file.
 *
 */



 /******************************************/


#define ACC_FLAG_USER   0x00000000
#define ACC_FLAG_OPER   0x00000001 
#define ACC_FLAG_ACCESS 0x00000002 
#define ACC_FLAG_MODULE 0x00000004
#define ACC_FLAG_LIST   0x00000008 
#define ACC_FLAG_JOIN   0x00000010
#define ACC_FLAG_SET    0x00000020
#define ACC_FLAG_DIE    0x00000040
#define ACC_FLAG_DEBUG  0x00000080

#define ACC_USER ACC_FLAG_USER

#define ACC_OPER ACC_FLAG_OPER | ACC_FLAG_USER

#define ACC_STAFF ACC_FLAG_OPER | ACC_FLAG_LIST | ACC_FLAG_USER

#define ACC_ADMN   \
 	ACC_FLAG_ACCESS | ACC_FLAG_LIST | \
        ACC_FLAG_OPER | ACC_FLAG_SET | \
        ACC_FLAG_JOIN | ACC_FLAG_USER | \
        ACC_FLAG_DEBUG

#define ACC_ROOT   \
	ACC_FLAG_OPER | ACC_FLAG_ACCESS | \
	ACC_FLAG_MODULE | ACC_FLAG_LIST | \
	ACC_FLAG_SET | ACC_FLAG_JOIN | \
	ACC_FLAG_DIE | ACC_FLAG_USER | \
    ACC_FLAG_DEBUG

#define is_oper(x)  ((x->access & ACC_OPER)? return 1 : return 0)
#define is_staff(x) ((x->access & ACC_STAFF)? return 1 : return 0)
#define is_admin(x) ((x->access & ACC_ADMN)? return 1 : return 0)
#define is_root(x)  ((x->access & ACC_ROOT)? return 1 : return 0)


typedef struct access_ {

    char name[30];

    char cname[30]; 

    uint32  flags;

    dlink_list hosts;

} Access;

dlink_list accesslist;


typedef struct confacc_ {
	char* name;
	
	uint32 flags;

       char* sym;
    
} ConfigAccess;



static ConfigAccess CfgAccess[] =
{
  { "root", ACC_ROOT, "R" },
  { "admin", ACC_ADMN, "A" },
  { "staff", ACC_STAFF, "S" },
  { "oper" , ACC_OPER, "O" },
  
  { "module", ACC_FLAG_MODULE, "m" },
  { "die", ACC_FLAG_DIE, "d" },
  { "set", ACC_FLAG_SET, "s" },
  { "list", ACC_FLAG_LIST, "l" },
  { "access", ACC_FLAG_ACCESS, "a" },

#ifdef USE_DEBUG_CMDS
  { "debug", ACC_FLAG_DEBUG,  "D" }
#endif 

};

int DestAccList();

int check_access(User*, uint32);
Access* find_access (User*);
void refresh_access (void);

int setAccess(User* u, int op);




