/**
 *           OMEGA SECURITY SERVICES
 *      (c) 2008 Omega Development Team
 *
 *      For COPYING please view LICENSE for
 *      instructions.
 *
 *   This module is for developer use only
 *   any use of this module in a non-developer
 *   matter, will result in void of any support
 *   if needed.
 *
 *   NOTE: RAW commands are potentially devastating
 *     to a sever, if done incorrectly.
 *
 */



#include "stdinc.h"
#include "server.h"

#define NAME "g_raw"
#define VERSION "$Id: g_raw.c 1438 2008-09-27 19:56:12Z twitch $"
#define AUTHOR "Twitch"


static void cmd_raw(User* u,char *params);
static void cmd_raw_help(User*);

static int Module_Init();
static void Module_Close();

MODHEADER(NAME, VERSION, AUTHOR, MAKE_ABI(0,5,2),Module_Init, Module_Close);

static int Module_Init()
{

    AddCmd(s_Guardian, "RAW", ACC_ROOT, cmd_raw);
    return MOD_CONT;

}

static void Module_Close()
{
	DelCmd(s_Guardian, "RAW",cmd_raw);
}

static void cmd_raw(User* u,char *params)
{
	     char msg[512];

	    strlcpy(msg,params,sizeof(msg));
	    char* src = strtok(msg," ");
            char* cmd = strtok(NULL," ");
            char* pr = strtok(NULL,"");


	     //some basic checks :)
            if (!params)
			sendto_one (s_Guardian, u, "Invalid Paramaters");


            send_line("%s %s %s",src,cmd,(pr)? pr : "");

            ircd_wallop(s_Guardian->nick,"%s (%s@%s) has used RAW command for \002%s\002",u->nick,u->user,u->host, (*src == ':')? cmd : src);

            return;
}


static void cmd_raw_help(User* u)
{
	sendto_one(s_Guardian, u, "SYNTAX \002RAW [PARAMATERS]\002");
	sendto_one(s_Guardian, u, "- ");
	sendto_one(s_Guardian, u, "This command allows a user to send RAW messages to the server");
	sendto_one(s_Guardian, u, "RAW is a server development tool only.");
	sendto_one(s_Guardian, u, "- ");
       sendto_one(s_Guardian, u, "\002Note:\002");
	sendto_one(s_Guardian, u, "Use of the RAW command is potentially harmfull to any production network");
	sendto_one(s_Guardian, u, "and should be avoided at all costs.");
	return;
}

