/**
 *           OMEGA SECURITY SERVICES
 *      (c) 2008 Omega Development Team
 *
 *      For COPYING please view LICENSE for
 *      instructions.
 *
 *         Handles Guardian SET options
 *
 */




#include "stdinc.h"
#include "server.h"
#include "extern.h"

#define NAME "g_set"
#define VERSION "$Id: g_set.c 1392 2008-09-11 05:45:25Z twitch $"
#define AUTHOR "Twitch"

extern int uselogchan;

static void cmd_set(User*,char *);

static void help_set(User*);
static void help_set_ext(User*);


static int Module_Init();
static void Module_Close();


MODHEADER(NAME, VERSION, AUTHOR, MAKE_ABI(0,5,2),Module_Init, Module_Close);



static int Module_Init()
{
	int ch, status = 0;


      Log("[%s] register module returned %s",NAME,GetModErr(status));

      ch = AddCmd(s_Guardian, "SET", ACC_FLAG_SET, cmd_set);

      AddHelp(s_Guardian, help_set);
      AddHelpExt(ch,s_Guardian,help_set_ext);


      uselogchan = 1;

      Log("[%s] load successfull command SET installed",NAME);

      return MOD_CONT;
}


static void Module_Close()
{



	DelCmd(s_Guardian, "SET", cmd_set);
	DelHelp(s_Guardian, help_set);
	return;
}


static void cmd_set(User* u, char *msg)
{
	char *params[512];
	int n;

       n = generictoken(' ',512,msg,params);
	if (n < 2)
		return;
       if (strcasecmp(params[0],"LOGCHAN")==0)
	{
		if (strcasecmp(params[1],"ON")==0)
			uselogchan = 1;
		else
			uselogchan = 0;
	}

	return;
}

static void help_set(User *u)
{
	sendto_one(s_Guardian,u,"SET - Allows you to set various options");
	return;

}

static void help_set_ext(User *u)
{
	sendto_one(s_Guardian,u,"Syntax: \002SET OPTION [PARAMETER]\002");
	sendto_one(s_Guardian,u,"  ");
	sendto_one(s_Guardian,u,"\002SET LOGCHAN [ON|OFF]");
	sendto_one(s_Guardian,u,"  ");
	sendto_one(s_Guardian,u,"      If ON is specified as a parameter - the server will start");
	sendto_one(s_Guardian,u,"      displaying log information into the logchan (%s) ",logchan);
	sendto_one(s_Guardian,u,"  ");
	sendto_one(s_Guardian,u,"      If OFF is specified as the parameter - the server will cease");
	sendto_one(s_Guardian,u,"      sending log information to the log channel.");
	sendto_one(s_Guardian,u,"  ");
	return;
}


